#region Header Licence
//  NKnobMan, Copyright 2009, Alexandre MUTEL.
// 
//  This is free software; you can redistribute it and/or modify it
//  under the terms of the GNU Lesser General Public License as
//  published by the Free Software Foundation; either version 2.1 of
//  the License, or (at your option) any later version.
// 
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//  Lesser General Public License for more details.
// 
//  You should have received a copy of the GNU Lesser General Public
//  License along with this software; if not, write to the Free
//  Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
//  02110-1301 USA, or see the FSF site: http://www.fsf.org.
#endregion
using System.Runtime.Serialization;

namespace NKnobMan
{

    [DataContract]
    public class LayerLayout : LayerItem
    {
        public LayerLayout(Layer layer) : base(layer)
        {
        }

        [DataMember, KnobManField]
        public FloatAnimateLayerItem Angle { get; internal set; }

        [DataMember, KnobManField]
        public FloatAnimateLayerItem Zoom { get; internal set; }

        [DataMember, KnobManField]
        public FloatAnimateLayerItem OffsetX { get; internal set; }

        [DataMember, KnobManField]
        public FloatAnimateLayerItem OffsetY { get; internal set; }


        private const string RotX = "RotCenterX";
        [DataMember, KnobManField(RotX)]
        public float RotationX
        {
            get { return Layer.GetValue<float>(RotX); }
            set { Layer.SetValue(RotX, value); }
        }

        private const string RotY = "RotCenterY";
        [DataMember, KnobManField(RotY)]
        public float RotationY
        {
            get { return Layer.GetValue<float>(RotY); }
            set { Layer.SetValue(RotY, value); }
        }
    }
}