#region Header Licence
//  NKnobMan, Copyright 2009, Alexandre MUTEL.
// 
//  This is free software; you can redistribute it and/or modify it
//  under the terms of the GNU Lesser General Public License as
//  published by the Free Software Foundation; either version 2.1 of
//  the License, or (at your option) any later version.
// 
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//  Lesser General Public License for more details.
// 
//  You should have received a copy of the GNU Lesser General Public
//  License along with this software; if not, write to the Free
//  Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
//  02110-1301 USA, or see the FSF site: http://www.fsf.org.
#endregion
using System.Runtime.Serialization;

namespace NKnobMan
{
    [DataContract]
    public class LayerLighting : LayerItem
    {
        public LayerLighting(Layer layer) : base(layer)
        {
            Specular = new LightSpecular(layer);
            DropShadow = new LightDropShadow(layer);
            InsideShadow = new LightInsideShadow(layer);
            EdgeHighlight = new LightEdgeHighlight(layer);
        }

        [DataMember]
        public LightSpecular Specular { get; private set; }

        [DataMember]
        public LightDropShadow DropShadow { get; private set; }

        [DataMember]
        public LightInsideShadow InsideShadow { get; private set; }

        [DataMember]
        public LightEdgeHighlight EdgeHighlight { get; private set; }
    }
}