#region Header Licence
//  NKnobMan, Copyright 2009, Alexandre MUTEL.
// 
//  This is free software; you can redistribute it and/or modify it
//  under the terms of the GNU Lesser General Public License as
//  published by the Free Software Foundation; either version 2.1 of
//  the License, or (at your option) any later version.
// 
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//  Lesser General Public License for more details.
// 
//  You should have received a copy of the GNU Lesser General Public
//  License along with this software; if not, write to the Free
//  Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
//  02110-1301 USA, or see the FSF site: http://www.fsf.org.
#endregion
using System;
using System.Runtime.Serialization;

namespace NKnobMan
{
    [DataContract]
    public class LightDropShadow : Light
    {
        public LightDropShadow(Layer layer) : base(layer)
        {
        }

        [DataMember, KnobManField("ShadowOffset")]
        public FloatAnimateLayerItem Offset { get; internal set; }

        [DataMember, KnobManField("ShadowDiffuse")]
        public IntAnimateLayerItem Diffuse { get; internal set; }

        [DataMember, KnobManField("LightDirD")]
        public override IntAnimateLayerItem Direction { get; internal set; }

        [DataMember, KnobManField("LightDirDEnable")]
        public bool DirectionEnable
        {
            get { return Layer.GetValue<bool>("LightDirDEnable"); }
            set { Layer.SetValue("LightDirDEnable", value); }
        }

        [DataMember, KnobManField("ShadowDensity", "ShadowDensity1", "ShadowDensity2")]
        public override IntAnimateLayerItem Density { get; internal set; }
    }
}